/**************************************************************************
 *
 *  Copyright (C) 2001-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Jeu de la Vie.
 *
 *	Jeu de la Vie is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Jeu de la Vie is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


////////////////////////////////////////////////////////////////////////////////////////////////////////

char* get_folder(void)
{
	short rang = 0, nbre = 0, decal = 0 ;
	char *folder ;

	baisse_contraste(100) ;
	clr_interface() ;
	draw_str_petit(7, 6, fr_eng("Choisissez un", "Choose a")) ;
	draw_str_petit(7, 14, fr_eng("dossier:", "folder:")) ;
	DrawLine(7, 24, 46, 24, 4) ;
	while ((folder = get_folder_n(nbre)) != NULL)
		if (nbre++ < 8) draw_str_petit(7, 22+8*nbre, folder) ;
	restaure_contraste() ;

	do
	{
		DrawChar(1, 30+8*(rang-decal), 18, 4) ;
		attend_touche(ANIMER_CELLULE) ;
		ScrRectFill(&(SCR_RECT){{1, 30, 6, 91}}, &ECRAN, 0) ;
		draw_str_petit(1, 30+8*(rang-decal), "  ") ;
		rang = (nbre+rang+(BAS != 0)-(HAUT != 0))%nbre ;
		if (rang-decal > 7)
		{
			ScrRectFill(&(SCR_RECT){{7, 30, 54, 90}}, &ECRAN, 0) ;
			for (decal = 0 ; decal < 8 ; decal++) draw_str_petit(7, 30+8*decal, get_folder_n(decal+rang-7)) ;
			decal = rang-7 ;
		}
		else if (rang < decal)
		{
			ScrRectFill(&(SCR_RECT){{7, 30, 54, 90}}, &ECRAN, 0) ;
			for (decal = 0 ; decal < 8 ; decal++) draw_str_petit(7, 30+8*decal, get_folder_n(decal+rang)) ;
			decal = rang ;
		}
	} while (ENTER == 0 && SECOND == 0 && ESCAPE == 0) ;
	if (ESCAPE != 0) return NULL ;
	return get_folder_n(rang) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

char* get_pic()
{
	short rang = 0, nbre = 0, decal = 0 ;
	unsigned char *var, bmp[2480], *folder ;

	while (1)
	{
		folder = get_folder() ;
		if (folder == NULL) return NULL ;
		baisse_contraste(100) ;
		clr_interface() ;
		while ((var = get_pic_n(folder, nbre)) != NULL)
			if (nbre++ < 8) draw_str_petit(7, 22+8*nbre, var) ;
		if (nbre == 0)
		{
			draw_str_petit(3, 15, fr_eng("Aucune image", "No picture")) ;
			draw_str_petit(3, 23, fr_eng("ici !", "here!")) ;
			restaure_contraste() ;
			attend_touche(RIEN_FAIRE) ;
			continue ;
		}
		break ;
	}
	SavTerrain(bmp) ;
	draw_str_petit(7, 6, fr_eng("Choisissez un", "Choose a")) ;
	draw_str_petit(7, 14, fr_eng("image:", "picture:")) ;
	DrawLine(7, 24, 46, 24, 4) ;
	restaure_contraste() ;

	do
	{
		DrawChar(1, 30+8*rang, 18, 4) ;
		ClrTerrain() ;
		var = get_ptr(get_entry(get_pic_n(folder, rang)))+2 ;
		bitmap_put(max(64,MilieuTerrainX-(var[3]>>1)), max(2,MilieuTerrainY-(var[1]>>1)), var, 1) ;
		attend_touche(ANIMER_CELLULE) ;
		ScrRectFill(&(SCR_RECT){{1, 30, 6, 91}}, &ECRAN, 0) ;
		rang = (nbre+rang+(BAS != 0)-(HAUT != 0))%nbre ;
		if (rang-decal > 7)
		{
			ScrRectFill(&(SCR_RECT){{7, 30, 54, 90}}, &ECRAN, 0) ;
			for (decal = 0 ; decal < 8 ; decal++) draw_str_petit(7, 30+8*decal, get_pic_n(folder, decal+rang-7)) ;
			decal = rang-7 ;
		}
		else if (rang < decal)
		{
			ScrRectFill(&(SCR_RECT){{7, 30, 54, 90}}, &ECRAN, 0) ;
			for (decal = 0 ; decal < 8 ; decal++) draw_str_petit(7, 30+8*decal, get_pic_n(folder, decal+rang)) ;
			decal = rang ;
		}
	} while (ENTER == 0 && SECOND == 0 && ESCAPE == 0) ;
	RestaureTerrain(bmp) ;
	if (ESCAPE != 0) return NULL ;
	return var ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void change_regle(void)
{
	static short num_regle = 7 ;
	short rang, largeur, decal = num_regle > 7 ? num_regle-7 : 0 ;
	short aveccell = 0, sanscell = 0 ;
	char *regle, bmp[2480] ;

	baisse_contraste(100) ;
	SavTerrain(bmp) ;
	Debut:
	clr_interface() ;
	draw_str_petit(7, 6, fr_eng("Slectionnez", "Select a")) ;
	draw_str_petit(7, 14, fr_eng("une rgle:", "rule:")) ;
	DrawLine(7, 24, 45, 24, 4) ;
	for (rang = decal ; rang < 8+decal ; rang++)
		draw_str_petit(7, 31+8*(rang-decal), Regles[rang]) ;
	rang = num_regle ;
	restaure_contraste() ;

	do
	{
		DrawChar(1, 31+8*(rang-decal), 18, 4) ;
		largeur = (str_petit_largeur(TitreRegles[rang]))>>1 ;
		ClrTerrain() ;
		draw_str_petit(MilieuTerrainX-largeur, 2, TitreRegles[rang]) ;
		DrawLine(MilieuTerrainX-largeur+1, 9, MilieuTerrainX+largeur-1, 9, 4) ;
		draw_str_petit(MilieuTerrainX-((str_petit_largeur(CaractRegles[rang]))>>1), 13, CaractRegles[rang]) ;
		draw_str_terrain(InfoRegles[rang], 23) ;
		attend_touche(ANIMER_CELLULE) ;
		ScrRectFill(&(SCR_RECT){{1, 31, 6, 92}}, &ECRAN, 0) ;
		rang = (NBRE_REGLES+rang+(BAS != 0)-(HAUT != 0))%NBRE_REGLES ;
		if (rang-decal > 7)
		{
			ScrRectFill(&(SCR_RECT){{7, 31, 61, 91}}, &ECRAN, 0) ;
			for (decal = 0 ; decal < 8 ; decal++) draw_str_petit(7, 31+8*decal, Regles[decal+rang-7]) ;
			decal = rang-7 ;
		}
		else if (rang < decal)
		{
			ScrRectFill(&(SCR_RECT){{7, 31, 61, 91}}, &ECRAN, 0) ;
			for (decal = 0 ; decal < 8 ; decal++) draw_str_petit(7, 31+8*decal, Regles[decal+rang]) ;
			decal = rang ;
		}
	} while (ENTER == 0 && SECOND == 0 && ESCAPE == 0) ;
	RestaureTerrain(bmp) ;
	if (ESCAPE != 0) return ;
	if (rang == 0)
	{
		regle = Regle ;
		clr_interface() ;
		DrawChar(1, 31, 18, 4) ;
		do
		{
			attend_touche(ANIMER_CELLULE) ;
			*regle = N0 ? 48 : (N1 ? 49 : (N2 ? 50 : (N3 ? 51 : (N4 ? 52 : (N5 ? 53 :
				(N6 ? 54 : (N7 ? 55 : (N8 ? 56 : (N9 ? 57 : (SLASH ? 47 : 0)))))))))) ;
			if (*regle != 0 && regle-Regle < 13) regle++ ;
			if (RETOUR != 0 && regle > Regle)
			{
				ScrRectFill(&(SCR_RECT){{7, 31, 54, 35}}, &ECRAN, 0) ;
				regle-- ;
			}
			*regle = 0 ;
			draw_str_petit(7, 31, Regle) ;
			if (ESCAPE != 0) goto Debut ;
		} while (ENTER == 0 && SECOND == 0) ;
		regle = Regle ;
	}
	else
	{
		regle = Regles[rang] ;
		strcpy(Regle, regle) ;
	}
	num_regle = rang ;
	while (*regle != 0)
	{
		if (*regle == '/')
		{
			aveccell = sanscell ;
			sanscell = 0 ;
		}
		else
			sanscell |= 1<<(*regle-'0') ;
		regle++ ;
	}
	asm("	move.w %0,%%d0 ; move.w %1,%%d1 ; jsr changer_reglesN
			move.w %0,%%d0 ; move.w %1,%%d1 ; jsr changer_reglesG
			" :: "d" (sanscell), "d" (aveccell) : "d0","d1") ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

char* get_motif()
{
	short rang = 0, nbre = 0, decal = 0 ;
	unsigned char *pic, *titre = NULL, *info = NULL, bmp[2480] ;

	baisse_contraste(100) ;
	clr_interface() ;
	if (Motifs == NULL)
	{
		draw_str_petit(3, 15, "Motifs.fLIF") ;
		draw_str_petit(3, 23, fr_eng("introuvable !", "not found!")) ;
		restaure_contraste() ;
		attend_touche(RIEN_FAIRE) ;
		return NULL ;
	}
	SavTerrain(bmp) ;
	draw_str_petit(7, 6, fr_eng("Choisissez un", "Choose a")) ;
	draw_str_petit(7, 14, fr_eng("motif:", "pattern:")) ;
	DrawLine(7, 24, 46, 24, 4) ;
	while (get_motif_n(nbre, &titre, &info) != NULL)
		if (nbre++ < 8) draw_str_petit(7, 22+8*nbre, titre) ;
	restaure_contraste() ;

	do
	{
		DrawChar(1, 30+8*(rang-decal), 18, 4) ;
		pic = get_motif_n(rang, &titre, &info) ;
		ClrTerrain() ;
		bitmap_put(max(64,MilieuTerrainX-(pic[3]>>1)), 5, pic, 1) ;
		draw_str_terrain(info, 9+pic[1]) ;
		attend_touche(ANIMER_CELLULE) ;
		ScrRectFill(&(SCR_RECT){{1, 30, 6, 91}}, &ECRAN, 0) ;
		rang = (nbre+rang+(BAS != 0)-(HAUT != 0))%nbre ;
		if (rang-decal > 7)
		{
			ScrRectFill(&(SCR_RECT){{7, 30, 61, 90}}, &ECRAN, 0) ;
			for (decal = 0 ; decal < 8 ; decal++)
			{
				get_motif_n(decal+rang-7, &titre, &info) ;
				draw_str_petit(7, 30+8*decal, titre) ;
			}
			decal = rang-7 ;
		}
		else if (rang < decal)
		{
			ScrRectFill(&(SCR_RECT){{7, 30, 61, 90}}, &ECRAN, 0) ;
			for (decal = 0 ; decal < 8 ; decal++)
			{
				get_motif_n(decal+rang, &titre, &info) ;
				draw_str_petit(7, 30+8*decal, titre) ;
			}
			decal = rang ;
		}
	} while (ENTER == 0 && SECOND == 0 && ESCAPE == 0) ;
	RestaureTerrain(bmp) ;
	if (ESCAPE != 0) return NULL ;
	return pic ;
}
