/**************************************************************************
 *
 *  Copyright (C) 2001-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Jeu de la Vie.
 *
 *	Jeu de la Vie is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Jeu de la Vie is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


/////////////////////////////////////////////////////////////////////////////////////////
//
//	Quasiment toutes ces procdures sont auto-pirates  Flib.
//
/////////////////////////////////////////////////////////////////////////////////////////

static inline unsigned short var_len(char *var)
{
	return (2+*(unsigned short*)var) ;
}

/////////////////////////////////////////////////////////////////////////////////////////

char *mk_nam(char *str)
{
	static char name[19] = {0} ;
	short len = strlen(str) ;

	if (len > 17) return NULL ;

	return strcpy(name+1, str)+len ;
}

/////////////////////////////////////////////////////////////////////////////////////////

static inline SYM_ENTRY *get_entry(char *str)
{
	return SymFindPtr(mk_nam(str), 0) ;
}

/////////////////////////////////////////////////////////////////////////////////////////

static inline char *get_ptr(SYM_ENTRY *entry)
{
	if (entry == NULL) return NULL ;
	return (char*)HeapDeref(entry->handle) ;
}

/////////////////////////////////////////////////////////////////////////////////////////

static inline void check(char *str)
{
	SYM_ENTRY *entry = get_entry(str) ;

	if (entry != NULL && entry->flags.bits.archived != 0)
	{
		EM_moveSymFromExtMem(mk_nam(str), HS_NULL) ;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////

char *mk_ptr(char *str, unsigned short taille)
{
	char *var ;
	SYM_ENTRY *entry ;

	check(str) ;

	entry = DerefSym(SymAdd(mk_nam(str))) ;
	if (entry == NULL) return NULL ;

	var = (char*)HeapDeref(entry->handle = HeapAlloc(taille)) ;
	if (entry->handle == H_NULL) return NULL ;

	*(unsigned short*)var = taille-2 ;

	return (var+2) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

char* get_folder_n(short n)
{
	SYM_ENTRY *entry = SymFindFirst(NULL, 4) ;

	do
	{
		if (n-- == 0) return entry->name ;
		entry = SymFindNext() ;
	} while (entry != NULL) ;
	return NULL ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

char* get_pic_n(char *folder, short n)
{
	SYM_ENTRY *entry = SymFindFirst(mk_nam(folder), 9) ;
	unsigned char *var ;

	do
	{
		var = get_ptr(entry) ;
		if (*(var+var_len(var)-1) == PIC_TAG) n-- ;
		if (n == -1) return entry->name ;
		entry = SymFindNext() ;
	} while (entry != NULL) ;
	return NULL ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void verif_motifs(void)
{
	Motifs = get_ptr(get_entry("motifs")) ;
	if (Motifs == NULL || memcmp(Motifs+2, "FL", 2) != 0 || memcmp(Motifs+var_len(Motifs)-6, "fLIF", 5) != 0) Motifs = NULL ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

char* get_motif_n(short n, unsigned char **titre, unsigned char **info)
{
	unsigned char *var = Motifs ;
	unsigned short i ;

	i = *(unsigned short*)(var+4+(n+n)) ;
	if (i == 0) return NULL ;
	var += i ;
	*titre = var ;
	while (*var++ != 0) ;
	*info = var ;
	while (*var++ != 0) ;
	return var ;
}
